# Pygame libs #
import pygame

# Game libs #
import graphics, audio, player, data, castle

DOCTOR_INITIAL_POSITION = (200, 350)
INITIAL_ROOM = (0, 0)
#LEFT_WALL  = (0,   480), (120, 320)
#RIGHT_WALL = (520, 320), (640, 480)

def fix_position((x, y)):
    if x < 95:
        x = 95
    elif x > 545:
        x = 545
    if y < 325:
        y = 325
    if y > 475:
        y = 475
    return (x, y)

def init():
    pygame.init()
    pygame.display.set_caption("I am the unstable")
    pygame.display.set_mode((640, 480))

def main():
    init()
    doctor = player.Doctor(DOCTOR_INITIAL_POSITION)
    maze   = castle.Castle()
    c_room = maze.get_room((0, 0))
    screen = pygame.display.get_surface()
    clock  = pygame.time.Clock()
    delay = 0
    for x in xrange(1000):
        if pygame.event.get(pygame.QUIT):
            return
        pygame.event.get([pygame.KEYUP, pygame.MOUSEMOTION])
        keys = pygame.event.get(pygame.KEYDOWN)
        directionals = pygame.key.get_pressed()
        (d_x, d_y) = (0, 0)
        if directionals[pygame.K_RIGHT]:
            d_x = 1
        elif directionals[pygame.K_LEFT]:
            d_x = -1
        if directionals[pygame.K_UP]:
            d_y = -1
        elif directionals[pygame.K_DOWN]:
            d_y = 1
        (x, y) = doctor.calculate_next_position((d_x, d_y), delay)
        (x, y) = fix_position((x, y))
        doctor.set_position((x, y))
        for door in c_room.get_exits():
            if door.has_point((x, y)):
                c_room = maze.get_room(door.get_next_room())
                doctor.set_position(door.get_entrance())
        doctor.update(directionals, delay)
        c_room.draw(screen)
        doctor.draw(screen)
        pygame.display.flip()
        delay = clock.tick(60)
